//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
//  File Format Converter: from SGI Logluv TIFF
//			 to 'lay', my simple little floating point image format
//
//	J. Tumblin 8/20/2002
// 
//	'lay' format:
//     binary storage; uint16 xsize, ysize, followed by
//     a raster scanned sequence of (xsize*ysize) pixels, where 
//	each pixel is a set of 3 float32 numbers in R,G,B order.
//
//	!!Careful!! on Intel/Windows machines byte-order is reversed from UNIX!!
//
//	Usage: tiff2lay [infile] [outfile]
//

#include <stdio.h>
#include <conio.h>			// for _kbhit() function
#include "hcfile.h"			// header file; uses Sam Leffler's TIFF 6.0a library

int main(int argc,char* argv[])
//=============================================================================
{
int i,j,tmp;
uint16 xsiz,ysiz;			// Image size,
HcFile inLuv;				// data structure for LogLUV form of TIFF
FILE *pFile;
double stoNits;				// Greg Ward's units conversion number.

	inLuv.putColorSys(hcRGB);	// set up TIFF file reader for RGB output.
	if(argc==1 || argv[1][0]=='?') 
	{
		printf("\nUsage: tiff2lay infile.logluvTIFF [outfile.lay] \n\n");
		printf("where 'lay' is a simple floating point image that \n");
		printf(" holds uint16 xsize,ysize, followed by xsize*ysize pixels\n");
		printf(" where a pixel is a sequence of 3 float32 values in RGB order\n");
		printf("\n Outfile defaults to 'out.lay'\n");
		return(1);
	}
	else 
    {
		inLuv.readOpen(argv[1]); 	//  open 1st 'directory' in .tif file 
//		inLuv.readOpen("synagogue.tif");
	}
	xsiz = (uint16)inLuv.getXsize();
	ysiz = (uint16)inLuv.getYsize();
	stoNits = inLuv.getStoNits();
	for(i=0; i<xsiz;i++) 
	{								// clear the scanline buffer,
		inLuv.scanline[i  ]=0.0;
		inLuv.scanline[i+1]=0.0;
		inLuv.scanline[i+2]=0.0;
	}
	if(argv[1]==NULL || argv[2]==NULL) 
    {
		pFile = fopen("out.lay","wb");	// default output filename
    }
	else
    {
		pFile = fopen(argv[2],"wb");
	}
	tmp = fwrite(&xsiz,sizeof(uint16),1,pFile);	// write array size;
	tmp += fwrite(&ysiz,sizeof(uint16),1,pFile);
	if(tmp!=2)
    {
		printf("\n!lay file write error!");
    }
	for(j=0; j<(int)ysiz; j++) 
    {								// then for each scanline in file,
		inLuv.readLine((long)j);
		if(j==0) 
		{			// (useful for debugging;)
			printf("1st 4 Z values:%f,%f,%f,%f\n",
			inLuv.scanline[0],inLuv.scanline[3],
			inLuv.scanline[6],inLuv.scanline[9]);
		}
		for(i=0; i<(int)xsiz; i++)
		{			// scale by stored scalefactor
			inLuv.scanline[3*i]   *= (float)stoNits;
			inLuv.scanline[3*i+1] *= (float)stoNits;
			inLuv.scanline[3*i+2] *= (float)stoNits;
			fwrite(&(inLuv.scanline[3*i]),sizeof(float),3,pFile);
			// and write values to file.
		}
	}
	// done! close the files.
	inLuv.close();
	fclose(pFile);
//    printf("Hit any key to exit...");
//  	while(_kbhit()!=1);		// wait here until user strikes a key.
	return(0);
}
 
