//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
//  File Format Converter: from SGI Logluv TIFF
//			 to 'jt', my simple little floating point image format
//
//	J. Tumblin 12/8/97
// 
//	'jt' format:
//     binary storage; uint16 xsize, ysize, followed by
//     a raster scanned sequence of (xsize*ysize) pixels, where 
//	each pixel is a set of 3 float32 numbers in R,G,B order.
//
//	!!Careful!! on Intel/Windows machines byte-order is reversed!
//
//	Usage: logluv2jt [infile] [outfile]
//
#include "logluv.h"
extern int lastcall(char *str);


int main(int argc,char* argv[])
//=============================================================================
{
  int i,j,tmp;
  uint16 xsiz,ysiz;
  HcFile inLuv;
  FILE *pFile;
  double stoNits;

  inLuv.putColorSys(hcRGB);	// set up TIFF file reader for RGB output.
  if(argc==1 || argv[1][0]=='?') 
      {
      printf("\nUsage: logluv2jt infile.logluv [outfile.jt] \n\n");
      printf("where 'jt' is simple floating point image that \n");
      printf(" holds uint16 xsize,ysize, followed by xsize*ysize pixels\n");
      printf(" where a pixel is a sequence of 3 float32 values in RGB order\n");
      printf("\n Outfile defaults to 'out.jt'\n");
      return(1);
      }
  else 
      {
      inLuv.readOpen(argv[1]); 	//  open 1st 'directory' in .tif file 
      }
  xsiz = (uint16)inLuv.getXsize();
  ysiz = (uint16)inLuv.getYsize();
  stoNits = inLuv.getStoNits();
  for(i=0; i<xsiz;i++) 
      {				// clear the scanline buffer,
      inLuv.scanline[i]=0.0;
      inLuv.scanline[i+1]=0.0;
      inLuv.scanline[i+2]=0.0;
      }
  if(argv[1]==NULL || argv[2]==NULL) 
      {
      pFile = fopen("out.jt","wb");	// default output filename
      }
  else
      {
      pFile = fopen(argv[2],"wb");
      }
  tmp = fwrite(&xsiz,sizeof(uint16),1,pFile);	// write array size;
  tmp += fwrite(&ysiz,sizeof(uint16),1,pFile);
  if(tmp!=2)
      {
      printf("\n!jt file write error!");
      }
  for(j=0; j<(int)ysiz; j++) 
      {				// then for each scanline in file,
      inLuv.readLine((long)j);
      if(j==0) 
	  {			// (useful for debugging;)
	  printf("1st 4 Z values:%f,%f,%f,%f\n",
		 inLuv.scanline[0],inLuv.scanline[3],
		 inLuv.scanline[6],inLuv.scanline[9]);
	  }
      for(i=0; i<(int)xsiz; i++)
	  {			// scale by stored scalefactor
	  inLuv.scanline[3*i]   *= stoNits;
	  inLuv.scanline[3*i+1] *= stoNits;
	  inLuv.scanline[3*i+2] *= stoNits;
	  fwrite(&(inLuv.scanline[3*i]),sizeof(float),3,pFile);
	  // and write values to file.
	  }
      }
  // done! close the files.
  inLuv.close();
  fclose(pFile);
}
 
